require 'cairo'
require 'cairo_xlib'
require 'imlib2'

function hex_to_rgba(color, alpha)
	return ((color/0x10000) % 0x100)/255, ((color/0x100) % 0x100)/255, (color % 0x100)/255, alpha
end

function image(im)
x=nil
x=(im.x or 0)
y=nil
y=(im.y or 0)
w=nil
w=(im.w or 0)
h=nil
h=(im.h or 0)
file=nil
file=tostring(im.file)
if file==nil then print("set image file") end

local show = imlib_load_image(file)
if show == nil then return end
imlib_context_set_image(show)
if tonumber(w)==0 then
width=imlib_image_get_width()
else
width=tonumber(w)
end
if tonumber(h)==0 then
height=imlib_image_get_height()
else
height=tonumber(h)
end
imlib_context_set_image(show)
local scaled=imlib_create_cropped_scaled_image(0, 0, imlib_image_get_width(), imlib_image_get_height(), width, height)
imlib_free_image()
imlib_context_set_image(scaled)
imlib_render_image_on_drawable(x, y)
imlib_free_image()
show=nil
end

function draw_letter_o1(cr, primary_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 16
	alpha = 1
	
	point1 = {x = 42, y = 422}
	point2 = {x = 42, y = 358}
	point3 = {x = 106, y = 358}
	point4 = {x = 106, y = 422}
	point5 = {x = 58, y = 422}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(primary_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_line_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_line_to (cr, point5.x, point5.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_shaded_o1(cr, shaded_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 32
	alpha = 1
	
	point1 = {x = 42, y = 422}
	point2 = {x = 42, y = 358}
	point3 = {x = 106, y = 358}
	point4 = {x = 106, y = 422}
	point5 = {x = 58, y = 422}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(shaded_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_line_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_line_to (cr, point5.x, point5.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_p(cr, primary_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 16
	alpha = 1
	
	point1 = {x = 138, y = 486}
	point2 = {x = 138, y = 358}
	point3 = {x = 202, y = 358}
	point4 = {x = 202, y = 422}
	point5 = {x = 154, y = 422}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(primary_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_line_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_line_to (cr, point5.x, point5.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_shaded_p(cr, shaded_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 32
	alpha = 1
	
	point1 = {x = 138, y = 486}
	point2 = {x = 138, y = 358}
	point3 = {x = 202, y = 358}
	point4 = {x = 202, y = 422}
	point5 = {x = 154, y = 422}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(shaded_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_line_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_line_to (cr, point5.x, point5.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_e(cr, primary_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 16
	alpha = 1
	
	point1 = {x = 298, y = 422}
	point2 = {x = 234, y = 422}
	point3 = {x = 234, y = 358}
	point4 = {x = 298, y = 358}
	point5 = {x = 298, y = 390}
	point6 = {x = 250, y = 390}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(primary_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_line_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_line_to (cr, point5.x, point5.y)
	cairo_line_to (cr, point6.x, point6.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_shaded_e(cr, shaded_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 32
	alpha = 1
	
	point1 = {x = 298, y = 422}
	point2 = {x = 234, y = 422}
	point3 = {x = 234, y = 358}
	point4 = {x = 298, y = 358}
	point5 = {x = 298, y = 390}
	point6 = {x = 250, y = 390}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(shaded_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_line_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_line_to (cr, point5.x, point5.y)
	cairo_line_to (cr, point6.x, point6.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_n(cr, primary_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 16
	alpha = 1
	
	point1 = {x = 330, y = 422}
	point2 = {x = 330, y = 358}
	point3 = {x = 394, y = 358}
	point4 = {x = 394, y = 422}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(primary_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_line_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_shaded_n(cr, shaded_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 32
	alpha = 1
	
	point1 = {x = 330, y = 422}
	point2 = {x = 330, y = 358}
	point3 = {x = 394, y = 358}
	point4 = {x = 394, y = 422}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(shaded_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_line_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_b(cr, primary_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 16
	alpha = 1
	
	point1 = {x = 426, y = 294}
	point2 = {x = 426, y = 422}
	point3 = {x = 490, y = 422}
	point4 = {x = 490, y = 358}
	point5 = {x = 442, y = 358}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(primary_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_line_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_line_to (cr, point5.x, point5.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_shaded_b(cr, shaded_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 32
	alpha = 1
	
	point1 = {x = 426, y = 294}
	point2 = {x = 426, y = 422}
	point3 = {x = 490, y = 422}
	point4 = {x = 490, y = 358}
	point5 = {x = 442, y = 358}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(shaded_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_line_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_line_to (cr, point5.x, point5.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_o2(cr, primary_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 16
	alpha = 1
	
	point1 = {x = 522, y = 422}
	point2 = {x = 522, y = 358}
	point3 = {x = 586, y = 358}
	point4 = {x = 586, y = 422}
	point5 = {x = 538, y = 422}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(primary_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_line_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_line_to (cr, point5.x, point5.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_shaded_o2(cr, shaded_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 32
	alpha = 1
	
	point1 = {x = 522, y = 422}
	point2 = {x = 522, y = 358}
	point3 = {x = 586, y = 358}
	point4 = {x = 586, y = 422}
	point5 = {x = 538, y = 422}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(shaded_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_line_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_line_to (cr, point5.x, point5.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_x(cr, primary_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 16
	alpha = 1
	
	point1 = {x = 618, y = 358}
	point2 = {x = 682, y = 422}
	point3 = {x = 618, y = 422}
	point4 = {x = 682, y = 358}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(primary_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_set_line_join (cr, linejoin)
	cairo_move_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end

function draw_letter_shaded_x(cr, shaded_color)
	linecap = CAIRO_LINE_CAP_ROUND
	linejoin = CAIRO_LINE_JOIN_ROUND
	thickness = 32
	alpha = 1
	
	point1 = {x = 618, y = 358}
	point2 = {x = 682, y = 422}
	point3 = {x = 618, y = 422}
	point4 = {x = 682, y = 358}
	
	cairo_set_line_width (cr, thickness)
	cairo_set_line_cap (cr, linecap)
	cairo_set_source_rgba (cr, hex_to_rgba(shaded_color, alpha))
	cairo_move_to (cr, point1.x, point1.y)
	cairo_line_to (cr, point2.x, point2.y)
	cairo_set_line_join (cr, linejoin)
	cairo_move_to (cr, point3.x, point3.y)
	cairo_line_to (cr, point4.x, point4.y)
	cairo_set_line_join (cr, linejoin)
	cairo_stroke (cr)
end


function conky_main(logocolor, primary_color, shaded_color)
	if conky_window == nil then	return end
	
	local cs = cairo_xlib_surface_create(conky_window.display,
										conky_window.drawable,
										conky_window.visual,
										conky_window.width,
										conky_window.height)
	cr = cairo_create(cs)
	local updates = tonumber(conky_parse('${updates}'))
	if updates > 1 then
		if logocolor == "cyan" then
			image({x=104, y=28, w=520, h=540, file="/data/configs/conky/dreamlan/cyan/images/png/gentoo-logo.png"})
		end
		if logocolor == "magenta" then
			image({x=104, y=28, w=520, h=540, file="/data/configs/conky/dreamlan/magenta/images/png/gentoo-logo.png"})
		end
		if logocolor == "yellow" then
			image({x=104, y=28, w=520, h=540, file="/data/configs/conky/dreamlan/yellow/images/png/gentoo-logo.png"})
		end
		draw_letter_shaded_o1(cr, shaded_color)
		draw_letter_o1(cr, primary_color)
		draw_letter_shaded_p(cr, shaded_color)
		draw_letter_p(cr, primary_color)
		draw_letter_shaded_e(cr, shaded_color)
		draw_letter_e(cr, primary_color)
		draw_letter_shaded_n(cr, shaded_color)
		draw_letter_n(cr, primary_color)
		draw_letter_shaded_b(cr, shaded_color)
		draw_letter_b(cr, primary_color)
		draw_letter_shaded_o2(cr, shaded_color)
		draw_letter_o2(cr, primary_color)
		draw_letter_shaded_x(cr, shaded_color)
		draw_letter_x(cr, primary_color)
	end
	cairo_destroy(cr)
	cairo_surface_destroy(cs)
	cr = nil
end
